/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : File1Reader.cc                                           */
/*                                                                       */
/*       Date : March 4, 1998                                            */
/* Updated at : March 4, 1998                                            */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <deffunc.h>

#include "File1Reader.h"
#include "SetCoverProblem.h"
#include "Column.h"

/*************************************************************************/
/*************************************************************************/
void File1Reader::setFileName(char *FileName)
{  sprintf(MyFileName,"%s", FileName); }

/*************************************************************************/
/*************************************************************************/
SetCoverProblem * File1Reader::read()
{  
   ifstream infile(MyFileName);

   int val, j,k;
   char *buf = new char[80];
   char line1[80];
   char line2[80];

   char ch;
   long int NumOfRows, NuOfVariables, NumOfNonZeros, TheBestIP;
   long int vals[4];
   long int ColumnNum, NonZeros, Profit ;
   double TheBestLP;
   int RowIndex[50];
   int Exit = 0;
   ulong i;
   
   i=j=0;

   //cout << "File name : " << MyFileName << endl;

   if(infile==NULL) 
   { cout << " File " << MyFileName << " does not found! " << endl; exit(1); }

   infile.getline(buf,80); //cout << buf << endl;
   istrstream strin(buf);
   strin >> NumOfRows;
   strin >> NuOfVariables;

   TheBestLP = atof(buf);

   //cout << endl;

   cout << " Report " << endl;
   cout << " Number of Rows      : " << NumOfRows << endl;
   cout << " Number of Variables : " << NuOfVariables << endl;
   cout << " Number of nonzeros  : " << vals[2] << endl;
   cout << " The Best Known Ip   : " << vals[3] << endl;
   cout << " The Best Known LP   : " << TheBestLP << endl;

   SetCoverProblem *SetCoverInstance = 
		   new SetCoverProblem(NumOfRows,NuOfVariables,vals[2],
				       vals[3],TheBestLP);

   delete[] buf;
   buf = new char[NumOfRows+20];
   char *profit;
   Column *p;
   ulong NZeros;
   int *ids;
   i=0;
   while(!infile.eof()&&!Exit&&i<NuOfVariables)
   {  
      NZeros = 0;
      infile.getline(buf,NumOfRows+20);
      profit = buf+NumOfRows+1;
      buf[NumOfRows]=NULL;

      for(j=0;j<NumOfRows;j++) if(buf[j]=='1') NZeros++;
      ids = new int[NZeros];
      for(k=0,j=0;j<NumOfRows;j++) if(buf[j]=='1') ids[k++]=j;
      SetCoverInstance->UpdateRow(i,NZeros,atof(profit),i,ids);
      delete[] ids;

      //cout << buf << endl; cout << profit << endl;
      i++;

   }// end of while

   infile.close();

   //(*SetCoverInstance).printRowInfo();
   //SetCoverInstance->sort();
   delete[] buf;

   return SetCoverInstance;

}// end of read

/*************************************************************************/
/*************************************************************************/
File1Reader::~File1Reader()
{
   cout << "deallocate" << endl;
}

/*************************************************************************/
/*************************************************************************/
SetCoverProblem * File1Reader::read2()
{  ifstream infile(MyFileName);
   int val, j,k;
   char buf[80];
   char line1[80];
   char line2[80];
   char ch;
   long int NumOfRows, NuOfVariables, NumOfNonZeros, TheBestIP;
   long int vals[4];
   long int ColumnNum, NonZeros, Profit ;
   double TheBestLP;
   int RowIndex[50];
   int Exit = 0;
   ulong i;
   
   i=j=0;

   cout << "File name : " << MyFileName << endl;

   if(infile) cout << " File is not Ok " << endl;

   while( (!infile.eof()) && (i<4))
   {  
      for(j=0;j<9;j++) 
      { infile.get( ch ); buf[j]=ch; 
	cout << j << ":" << ch << ":" ;
      }
      buf[j]=NULL;
      cout << "buf :" << buf << ":" << " int val :"<< atoi(buf) << endl;
      vals[i] = atoi(buf);
      i++;
   }

   infile.getline(buf,80);
   cout << buf << endl;
   TheBestLP = atof(buf);

   cout << endl;

   cout << " Report " << endl;
   cout << " Number of Rows      : " << vals[0] << endl;
   cout << " Number of Variables : " << vals[1] << endl;
   cout << " Number of nonzeros  : " << vals[2] << endl;
   cout << " The Best Known Ip   : " << vals[3] << endl;
   cout << " The Best Known LP   : " << TheBestLP << endl;


   SetCoverProblem *SetCoverInstance = new SetCoverProblem(vals[0],vals[1],vals[2], vals[3],TheBestLP);
   i=0;
   while(!infile.eof()&&!Exit)
   {  
      infile.getline(line1,80);
      if(infile.eof()) Exit=1;
      if(!Exit) infile.getline(line2,80);
      if(infile.eof()) Exit=1;

      if(!Exit)
      {  
	 for(j=0;j<7;j++) buf[j] = line1[j]; buf[j]=NULL; 
         Profit = atoi(buf);
         for(j=0;j<3;j++) buf[j] = line1[j+7]; buf[j]=NULL; 
         NonZeros = atoi(buf);
         for(j=0;j<8;j++) buf[j] = line1[j+10]; buf[j]=NULL; 
         ColumnNum = atoi(buf);

         for(j=0;j<NonZeros;j++)
         {  for(k=0;k<4;k++) buf[k] = line2[k+j*4]; buf[k]=NULL;
	    RowIndex[j] = atoi(buf)-1;
         }
      
	 (*SetCoverInstance).UpdateRow(i,NonZeros,Profit,ColumnNum,RowIndex);

         i++;
      }// end of if

   }// end of while

   infile.close();

   //(*SetCoverInstance).printRowInfo();
   SetCoverInstance->sort();

   return SetCoverInstance;

}// end of read

/*************************************************************************/
/**
   for OR-Library
   ftp://mscmga.ms.ic.ac.uk/pub/

   numberofrows numberofcolumns
   cost0 cost1 cost2 ....  cost14
   cost15 ....
   ...
   ...
   numberofcolumnscoveringrowi
   columnindices
**/
/*************************************************************************/
SetCoverProblem * File1Reader::readORLib()
{  
   ifstream infile(MyFileName);
   int val, j,k;
   char buf[80];
   char line1[80];
   char line2[80];
   char ch;
   long int NumOfRows, NuOfVariables, NumOfNonZeros, TheBestIP;
   long int vals[4];
   long int ColumnNum, NonZeros, Profit ;
   double TheBestLP=-1;
   int *RowIndex;
   double *costs ;
   int Exit = 0;
   ulong i;
   
   i=j=0;

   for(i=0;i<4;i++) vals[i]=-1;

   cout << "File name : " << MyFileName << endl;

   if(infile) cout << " File is not Ok " << endl;

   infile >> NumOfRows >> NuOfVariables ;

   cout << "Number of Rows : " << NumOfRows << endl;
   cout << "Number of Cols : " << NuOfVariables << endl;

   costs = new double[NuOfVariables];
   RowIndex = new int[NuOfVariables];

   // read cost values
   i=0;
   while(!infile.eof()&&i<NuOfVariables) 
   { infile>>costs[i]; i++; }// end of while

   for(j=0;j<NuOfVariables/10;j++) 
       cout << " costs[" << j*10 << "] : " << costs[j*10] << endl;
   cout << " costs[" << NuOfVariables-1 
	<< "] : " << costs[NuOfVariables-1] << endl;

   Column **cols = new Column*[NuOfVariables];
   for(j=0;j<NuOfVariables;j++)
   {
      cols[j] = new Column(NumOfRows);
      cols[j]->setProfit(costs[j]);
      cols[j]->setIndex(j);
   }

   SetCoverProblem *SetCoverInstance = new SetCoverProblem(NumOfRows,NuOfVariables,vals[2], vals[3],TheBestLP);
   i=0;
   while(!infile.eof()&&i<NumOfRows)
   {  
      infile >> NonZeros;
      for(j=0;j<NonZeros;j++) infile>>RowIndex[j];

      for(j=0;j<NonZeros;j++) cols[RowIndex[j]-1]->set(i);
	
      //(*SetCoverInstance).UpdateRow(i,NonZeros,costs[i],i,RowIndex);
      //SetCoverInstance->).UpdateRow(i,NonZeros,costs[i],i,RowIndex);
      cout << " row# " << i ;
      cout << " { ";
      for(j=0;j<NonZeros;j++)
      {
	 cout << RowIndex[j] << " ";
	 if(j%10==0) cout << "         " << endl;
      }
      cout << " } " << endl;
      i++;

   }// end of while

   infile.close();

   for(j=0;j<NuOfVariables;j++) SetCoverInstance->addColumn(cols[j]);
   SetCoverInstance->sort();

   delete[] costs;
   delete[] RowIndex;
   delete[] cols;

   return SetCoverInstance;

}// end of read

